# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) 2024 GongEn Contributors

if (WIN32)
	set(gongen_platform "windows")
else () # TODO check
	set(gongen_platform "linux")
endif ()

include(${gongen_directory}/cmake/macros.cmake)
include(${gongen_directory}/cmake/modules.cmake)

include(${CMAKE_SOURCE_DIR}/.cgen/deps.cmake OPTIONAL)

set(gongen_include_dir "${gongen_directory}/include")

gongen_add_gsf_schema_bank(gongen "${gongen_directory}/gsf")

macro (gongen_config)
	set(arg_options STATIC LTO)
	set(arg_one_var SUFFIX)
	set(arg_multi_var MODULES)
	cmake_parse_arguments(_arg "${arg_options}" "${arg_one_var}" "${arg_multi_var}" ${ARGN})
	set(_target_name "gongen")
	if (_arg_SUFFIX)
		string(APPEND _target_name "_${_arg_SUFFIX}")
	endif ()
	set(_sources)
	set(_definitions)
	if (NOT _arg_MODULES)
		set(_arg_MODULES "${gongen_module_list}")
	endif ()
	foreach (_mod IN LISTS _arg_MODULES)
		string(TOUPPER ${_mod} _mod_upper)
		list(APPEND _definitions "GEN_MOD_${_mod_upper}")
		list(APPEND _sources "${gongen_mod_${_mod}_sources}")
		foreach (_other IN LISTS gongen_mod_${_mod}_require)
			if (NOT DEFINED gongen_mod_${_other})
				message(FATAL_ERROR "Unknown GongEn module '${_other}' required by module '${_mod}'!")
			endif ()
			if (NOT (_other IN_LIST _arg_MODULES))
				message(FATAL_ERROR "Missing GongEn module '${_other}' required by module '${_mod}'!")
			endif ()
		endforeach ()
		foreach (_dep IN LISTS gongen_mod_${_mod}_deps)
			string(TOUPPER ${_dep} _dep_upper)
			list(APPEND _definitions "GEN_DEP_${_dep_upper}")
			if (NOT DEFINED gongen_dep_${_dep})
				message(FATAL_ERROR "Missing GongEn dependency '${_dep}' required by module '${_mod}'!")
			endif ()
			gongen_target_use_dep_inject("_sources" ${_dep})
		endforeach ()
	endforeach ()
	if (NOT _arg_STATIC)
		add_library(${_target_name} SHARED ${_sources})
		target_compile_definitions(${_target_name} PRIVATE GEN_BUILD)
	else ()
		add_library(${_target_name} STATIC ${_sources})
		if (_arg_LTO)
			set_property(TARGET ${_target_name} PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
		endif ()
		target_compile_definitions(${_target_name} PUBLIC GEN_BUILD_STATIC)
	endif ()
	if(NOT MSVC)
		target_compile_options(${_target_name} PUBLIC "-Wno-c99-designator")
		target_compile_options(${_target_name} PUBLIC "-Wno-nullability-completeness")
	endif()
	target_compile_definitions(${_target_name} PUBLIC "${_definitions}" IMGUI_USER_CONFIG=<gongen/imgui/imconfig.h>)
	foreach (_mod IN LISTS _arg_MODULES)
		foreach (_dep IN LISTS gongen_mod_${_mod}_deps)
			gongen_target_use_dep(${_target_name} ${_dep})
		endforeach ()
	endforeach ()
	target_include_directories(${_target_name} PUBLIC ${gongen_include_dir})
	if(WIN32)
		target_link_libraries(${_target_name} PRIVATE ws2_32 dbghelp shlwapi opengl32)
		target_link_options(${_target_name} PRIVATE 
			/NATVIS:${gongen_directory}/gongen.natvis
		)
	endif()
	target_compile_definitions(${_target_name} PUBLIC ${gongen_schema_banks})
endmacro ()
